
/***********************************************************************
 |
 |	RS232C Win32 ʃTu[`Cu
 |
 ||		qrQRQb֘A
 |
 |			rs.c
 |
 |		Ver 1.00    1994/12/12  HAMA
 |		Ver 2.00	1998/11/19	M.HAMA	Win32Ή
 |
 ************************************************************************/

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "rs.h"

#ifdef __cplusplus
extern "C" {
#endif

	/* RS232Cč\ */
typedef struct _RS232CSET {
	CHAR	portName[6];		/* ߰Ĕԍ(COM1, COM2...) */
	DCB	dcb;					/* DCB\ */
	COMMTIMEOUTS	ctmo;		/* COMMTIMEOUTS\ */
} RS232CSET, *LPRS232CSET;

static	int	RsPrmcheck(LPRSPRM, LPRS232CSET);

static	HANDLE	rsDev;
static	int	open_flag;
static	int	duplex;
static	DWORD	tmStart;
static	DWORD	tmSetSec;

/*=======================================================================
 |
 |		qr|QRQbI[v
 |
 |	int	RsOpen(LPSTR rsprm)
 |
 |		LPSTR	rsprm;		qr|QRQbI[vp[^
 |
 |		Ԓl		OF
 |					PFd[hp[^G[
 |					QF{[[gp[^G[
 |					RFpeB[p[^G[
 |					SFLN^p[^G[
 |					TFXgbvrbgp[^G[
 |					UFCOMp[^G[
 |					VFI[vG[
 |					WFdĂȂAڑĂȂB
 |
 =======================================================================*/
int	RsOpen(LPSTR prm)
{
	RS232CSET	rs232cset;
	LPRSPRM	lpParam;
	int	rt;

	lpParam = (LPRSPRM)prm;

	if ((rt = RsPrmcheck((LPRSPRM)lpParam, (LPRS232CSET)&rs232cset)) != 0)
		return(rt);

	/*  */
	if ((rsDev = CreateFile(rs232cset.portName, GENERIC_READ | GENERIC_WRITE, 0,
			NULL, OPEN_EXISTING, 0, NULL))	== INVALID_HANDLE_VALUE) {
		return(7);
	}

	/* Mޯ̧ */
	if (!SetupComm(rsDev, 1200, 1200)) {
		CloseHandle(rsDev);
		return(7);
	}

	/* RS232C */
	if (!SetCommState(rsDev, &rs232cset.dcb)) {
		CloseHandle(rsDev);
		return(7);
	}

	/* ѱĎԐݒ */
	if (!SetCommTimeouts(rsDev, &rs232cset.ctmo)) {
		CloseHandle(rsDev);
		return(7);
	}

	open_flag = 1;

	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbI[vp[^`FbN
 |
 |	int	RsPrmcheck(RSPRM *rsprm, LPRS232CSET rs232cset)
 |
 |		RSPRM	*rsprm;		qr|QRQbI[vp[^
 |		LPRS232CSET	rs232cset	p[^ҏWobt@
 |
 |		Ԓl			OFp[^
 |					PFd[hp[^G[
 |					UFbmp[^G[
 |	
 =======================================================================*/
static int RsPrmcheck(LPRSPRM rsprm, LPRS232CSET rs232cset)
{
	/* d[hp[^`FbN */
	switch (duplex = rsprm->duplex) {
	case DUPLEX_FULL:	/* Sd */
		break;
	case DUPLEX_HALF:	/* d */
		break;
	default:
		return(1);	/* p[^G[ */
	}

	/* bm`FbN */
	switch (rsprm->comno) {
	case COM1:	/* COM1 */
	case COM2:	/* COM2 */
	case COM3:	/* COM3 */
		break;
	default:	/* p[^G[ */
		return(6);
	}

	duplex = rsprm->duplex;

	memset(&rs232cset->dcb, 0, sizeof(DCB));
	rs232cset->dcb.DCBlength = sizeof(DCB);
	rs232cset->dcb.BaudRate = rsprm->blt;
	rs232cset->dcb.fBinary = TRUE;
	rs232cset->dcb.fOutxCtsFlow = TRUE;
	rs232cset->dcb.fDtrControl = DTR_CONTROL_ENABLE;
	rs232cset->dcb.fRtsControl = RTS_CONTROL_ENABLE;
	rs232cset->dcb.ByteSize = rsprm->chr_len;
	rs232cset->dcb.Parity = rsprm->parity;
	rs232cset->dcb.StopBits = rsprm->stp_len;
	rs232cset->dcb.XonChar = 0x11;
	rs232cset->dcb.XoffChar = 0x13;

	memset(&rs232cset->ctmo, 0, sizeof(COMMTIMEOUTS));
	rs232cset->ctmo.ReadTotalTimeoutConstant = 3000;
	rs232cset->ctmo.WriteTotalTimeoutConstant = 3000;

	sprintf(rs232cset->portName, "COM%d", rsprm->comno + 1);
			
	return(0);
}

/*=======================================================================
 |
 |		qr|QRQbN[Y
 |
 |	VOID	RsClose(VOID)
 |
 =======================================================================*/
VOID RsClose()
{
	/* I[vȂ牽Ȃ */
	if (open_flag == 0)
		return;

	PurgeComm(rsDev, PURGE_RXABORT | PURGE_RXCLEAR);
	CloseHandle(rsDev);

	open_flag = 0;		/* I[vtOZbg */
}

/*=======================================================================
 |
 |		PM
 |
 |	int	RsGet(VOID)
 |
 |		Ԓl		M
 |
 =======================================================================*/
DWORD	RsGet()
{
	DWORD	fModemStatus;
	DWORD	numBytes;
	CHAR	buf[2];
	DWORD	c;

	/* DSR`FbN */
	GetCommModemStatus(rsDev, &fModemStatus);
	if (!(fModemStatus & MS_DSR_ON))
		return(0x100);

	/* 1ǂݍ */
	if (!ReadFile(rsDev, buf, 1, &numBytes, NULL))
		return(0xffff);

	if (numBytes != 1)
		return(0x200);

	c = (DWORD)(buf[0] & 0xff);

	return(c);
}

/*=======================================================================
 |
 |		PM
 |
 |	VOID	RsPut(c)
 |
 |		int	c;		M
 |
 =======================================================================*/
BOOL RsPut(int c)
{
	DWORD	numBytes;
	char	buf;
	
	if (open_flag == 0)
		return(FALSE);

	buf = (char)c;
	
	return(WriteFile(rsDev, &buf, 1, &numBytes, NULL));
}

/*=======================================================================
 |
 |		ubNM
 |
 |	VOID	RsSend(LPSTR s, int len)
 |
 |		LPSTR	s;		M
 |		int	len;		
 |
 =======================================================================*/
BOOL RsSend(LPSTR s, int len)
{
	if (open_flag == 0)
		return(FALSE);

	if (len == 0)
		return(FALSE);

	if (duplex == DUPLEX_HALF) {
		/* MAM֎~AqsrI */
		RsRts(1);
	}

	/* f[^M */
	while (len--){
		if (! RsPut(*s++))
			return(FALSE);
	}

	if (duplex == DUPLEX_HALF) {
		/* ҂ */
		TmWait(5);	

		/* MAqsrIt */
		RsRts(0);
	}
	return(TRUE);
}

/*=======================================================================
 |
 |		csq
 |
 |	VOID	RsDtr(sw);
 |
 |		int	sw;		OFcsqIt@OFcsqI
 |
 =======================================================================*/
VOID RsDtr(int sw)
{
	EscapeCommFunction(rsDev, sw == 0 ? CLRDTR: SETDTR);
}

/*=======================================================================
 |
 |		qsr
 |
 |	VOID	RsRts(sw);
 |
 |		int	sw;		OFqsrIt@OFqsrI
 |
 =======================================================================*/
VOID RsRts(int sw)
{
	/* RTS@*/
	EscapeCommFunction(rsDev, sw == 0 ? CLRRTS : SETRTS);

	/* ҂ */
	TmWait(sw == 0 ? 1 : 24);	
}

/*=======================================================================
 |
 |		crqԕω`FbN
 |
 |	int	RsDsr()
 |
 |		Ԓl	OFcrqԕύX@PFcrqԕύX
 |
 =======================================================================*/
int RsDsr()
{
	DWORD	fModemStatus;

	GetCommModemStatus(rsDev, &fModemStatus);
	return(fModemStatus & MS_DSR_ON);
}

/*=======================================================================
 |
 |		LA`FbN
 |
 |	int	RsCd()
 |
 |		Ԓl		OFLAIt@PFLAI
 |
 =======================================================================*/
int	 RsCd()
{
	DWORD	fModemStatus;

	GetCommModemStatus(rsDev, &fModemStatus);
	return(fModemStatus & MS_RLSD_ON);
}

/*=======================================================================
 |
 |		bsr`FbN
 |
 |	int	RsCts()
 |
 |		Ԓl		OFbsrIt@PFbsrI
 |
 =======================================================================*/
int	 RsCts(void)
{
	DWORD	fModemStatus;

	GetCommModemStatus(rsDev, &fModemStatus);
	return(fModemStatus & MS_CTS_ON);
}

/*=======================================================================
 |
 |		^C}Jn
 |
 |	VOID	TmSet(int m)
 |
 |		int	m;		ԁiPOPʁj
 |
 =======================================================================*/
VOID TmSet(int m)
{
	tmStart = GetTickCount();
	tmSetSec = (DWORD)m;
}

/*=======================================================================
 |
 |		^CAEg`FbN
 |
 |	BOOL	TmCheck()
 |
 |		Ԃl		OFԓ	PF^CAEg
 |
 =======================================================================*/
BOOL TmCheck()
{
	DWORD	tt;

	tt = GetTickCount();

	return(((tt - tmStart) / 10L >= tmSetSec));
}

/*=======================================================================
 |
 |		EGCg
 |
 |	VOID	TmWait(int m)
 |
 |		int	m;		ԁiPOPʁj
 |
 =======================================================================*/
VOID TmWait(int m)
{
	TmSet(m);
	for(;;){
		if (TmCheck())
			break;
	}
}

#ifdef __cplusplus
}
#endif
